
// Used for View protocol

//
// State of the debugger apropos the inferior
//
typedef enum {
    DBG_STATE_NOT_ACTIVE,
    DBG_STATE_ACTIVE,		/* debugger running, no inferior */
    DBG_STATE_INFERIOR_LOADED,	/* inferior loaded */
    DBG_STATE_INFERIOR_EXITED,	/* exited either normally or due to crash */
    DBG_STATE_INFERIOR_LOGICALLY_RUNNING, /* For GUI issues; when logically running,
                                           * user has issued an explict run or continue command
                                           * whereas the inferior will be running for a next
                                           * or step command, it won't be logically running.
                                           */
    DBG_STATE_INFERIOR_RUNNING,	/* running under control of the debugger */
    DBG_STATE_INFERIOR_STOPPED	/* stopped at a breakpoint or due to attach */
} DebuggerState;


// Used for the Gui protocol

//
// Breakpoint states
//

typedef enum {
    BP_STATE_NEW,
    BP_STATE_ENABLED,
    BP_STATE_DISABLED,
    BP_STATE_OTHER_INFO_CHANGED,
    BP_STATE_DELETED,
    BP_STATE_MOVED
} BreakpointState;



//
// Output from GDB types
//
typedef enum {
    GDB_OUTPUT_STDOUT,
    GDB_OUTPUT_STDERR,
    GDB_OUTPUT_ANNOTATION,
    GDB_OUTPUT_OTHER
} GdbOutputType;

