#import <SegmentManager.h>
#import "threads.h"

typedef struct _ThreadInfo {
#ifdef GDB_HPPA
    REGS_STRUCT *frameRegs;
    FP_REGS_STRUCT *fpRegs;
    USER_REG_STRUCT *intRegs;
#else
    REGS_STRUCT *intRegs;
    FP_REGS_STRUCT *fpRegs;
    USER_REG_STRUCT *userReg;
#endif GDB_HPPA
#ifdef GDB_88K
   struct _m88110_thread_state_impl *implRegs;
#endif GDB_88K
} ThreadInfo;

#if  defined(GDB_HPPA)
#define THREADINFO_NAME_STATE(threadInfo) (threadInfo).intRegs
#define THREADINFO_PC_STATE(threadInfo) (threadInfo).frameRegs
#elif defined(GDB_SPARC)
#define THREADINFO_NAME_STATE(threadInfo) (threadInfo).intRegs
#define THREADINFO_PC_STATE(threadInfo) (threadInfo).intRegs
#else
#define THREADINFO_NAME_STATE(threadInfo) (threadInfo).userReg
#define THREADINFO_PC_STATE(threadInfo) (threadInfo).intRegs
#endif


@interface SegmentManager (Threads)
-(ThreadInfo *)threadInfos;
-(BOOL)threadInfo: (ThreadInfo *)tInfo forThreadNum: (int)tNum;
-(int)numThreads;
@end
